package jalview.datamodel;

import static org.testng.AssertJUnit.assertEquals;

import jalview.util.MapList;

import java.util.Arrays;

import org.testng.annotations.Test;

/**
 * Test class refactored from main method
 */
public class MappingTest
{
  /**
   * trite test of the intersectVisContigs method for a simple DNA -> Protein
   * exon map and a range of visContigs
   */
  @Test(groups ={ "Functional" })
  public void testIntersectVisContigs()
  {
    MapList fk = new MapList(new int[]
    { 1, 6, 8, 13, 15, 23 }, new int[]
    { 1, 7 }, 3, 1);
    Mapping m = new Mapping(fk);
    Mapping m_1 = m.intersectVisContigs(new int[]
    { fk.getFromLowest(), fk.getFromHighest() });
    Mapping m_2 = m.intersectVisContigs(new int[]
    { 1, 7, 11, 20 });

    // assertions from output values 'as is', not checked for correctness
    String result = Arrays.deepToString(m_1.map.getFromRanges()
            .toArray());
    System.out.println(result);
    assertEquals("[[1, 6], [8, 13], [15, 23]]", result);

    result = Arrays.deepToString(m_2.map.getFromRanges().toArray());
    System.out.println(result);
    assertEquals("[[1, 6], [11, 13], [15, 20]]", result);
  }

}
